let metric = ref ""

let whitespace = Str.regexp "[ \t,]+"

let elements = ref [||]

let _ = 
  Arg.parse [] (fun x -> metric := x) "and";
  let lexbuf = Lexing.from_channel stdin in
  try while true do
    let line = read_line () in
    let example = Str.split whitespace line in
    let example = List.rev example in
    let example = List.map (fun x -> int_of_string x >= 1 ) example in 
    let label = List.hd example 
    and features = List.rev (List.tl example) in
    let neg_features = List.map (fun x -> not x) features in
    let features = Array.of_list (features @ neg_features) in
    
    if Array.length features <> Array.length !elements 
    then elements := Array.create (Array.length features) true;
    
    let result = ref true in
    
    Array.iteri (fun i _ -> if !elements.(i) & not features.(i) then result := false) features;
    
    print_int (if !result then 1 else 0);
    print_newline ();
    
    Array.iteri (fun i _ -> if label & !elements.(i) & not features.(i) then !elements.(i) <- false) features;    
  done
  with
    End_of_file -> 
      print_string "final concept = ";
      let last = ref false in
      Array.iteri (fun i x -> 
	if x 
	then begin 
	  if !last then print_string "and "
	  else last := true;
	  if i > (Array.length !elements / 2) -1
	  then begin 
	    print_string "not "; 
	    print_int (i - Array.length !elements / 2); 
	    print_char ' '; 
	  end
	  else 
	    begin 
	      print_int i; 
	      print_char ' ' 
	    end
	end
	 ) !elements;
      print_newline()
